/** 
* @file Conversions.h
* @brief boring conversions
* @author Erik Rodner
* @date 02/19/2008

*/
#ifndef CONVERSIONSINCLUDE
#define CONVERSIONSINCLUDE


#include "core/image/ImageT.h"
#include "core/vector/VectorT.h"
#include "core/vector/MatrixT.h"
 
#include <vector>


namespace OBJREC {

/** @brief boring data conversions */
class Conversions
{

    protected:

    public:
  
	/** simple constructor */
	Conversions();
      
	/** simple destructor */
	virtual ~Conversions();

	static std::vector<double> stl_vector ( const NICE::Vector & x );

	static void resizeImage ( const NICE::Image & src, NICE::Image & dst, int newWidth, int newHeight );
	static void resizeImage ( const NICE::ColorImage & src, NICE::ColorImage & dst, int newWidth, int newHeight );

	static NICE::Image ReadImgAdv ( const std::string & filename, int normalizeWidth = -1, int normalizeHeight = -1 );
     
};


} // namespace

#endif
