/** 
* @file PascalResults.h
* @brief read and write pascal style results
* @author Erik Rodner
* @date 09/09/2008

*/
#ifndef PASCALRESULTSINCLUDE
#define PASCALRESULTSINCLUDE

#include <map>
#include <string>
#include "LocalizationResult.h"
#include "ClassNames.h"
  

namespace OBJREC {

/** read and write pascal style results */
class PascalResults
{

    protected:

    public:
    
	static void read ( 
	    std::map<std::string, LocalizationResult *> & results, 
	    std::string filename,
	    int classno = 1,
	    int backgroundClassno = 0,
	    bool calibrate = false);

	static void write ( char *templatefn, 
			    const std::string & imgfn,
			    const LocalizationResult & l,
			    const ClassNames & classNames );



};


} // namespace

#endif
