/** 
* @file DTBPruning.h
* @brief simple pruning methods
* @author Erik Rodner
* @date 05/06/2008

*/
#ifndef DTBPruningINCLUDE
#define DTBPruningINCLUDE

#include "core/vector/VectorT.h"
#include "core/vector/MatrixT.h"

#include "DecisionTreeBuilder.h"


namespace OBJREC {

/** build decision trees */
class DTBPruning : public DecisionTreeBuilder
{
    protected:
	double minimum_entropy;
	DecisionTreeBuilder *builder;

    public:
  
	/** simple constructor */
	// refactor-nice.pl: check this substitution
	// old: DTBPruning( const NICE::Config *conf, string section, DecisionTreeBuilder *builder );
	DTBPruning( const NICE::Config *conf, std::string section, DecisionTreeBuilder *builder );
      
	/** simple destructor */
	virtual ~DTBPruning();
     
	DecisionNode *build ( const FeaturePool & fp, 
		     const Examples & examples, int maxClassNo );


};


} // namespace

#endif
