/** 
* @file FCFPFeature.h
* @brief use an fpfeature
* @author Erik Rodner
* @date 11/15/2007

*/
#ifndef FCFPFeatureINCLUDE
#define FCFPFeatureINCLUDE

#include "vislearning/features/fbase/FeatureFactory.h"
#include "vislearning/features/fpfeatures/ImageFeatures.h"


namespace OBJREC {

class FCFPFeature : public FeatureFactory
{

    protected:
	ImageFeatures imgf;
    
    public:
  
	/** simple constructor */
	FCFPFeature ( const NICE::Config *conf );
      
	/** simple destructor */
	virtual ~FCFPFeature();
    
	/** convert image into feature vector */
	int convertRGB ( const NICE::ColorImage & img, NICE::Vector & vec );
	
	/** convert image into feature vector */
	int convert ( const NICE::Image & img, NICE::Vector & vec );

};


} // namespace

#endif
