/** 
 * @file IDKLTSampling.h
 * @brief random interest point sampling
 * @author Erik Rodner
 * @date 02/05/2008

 */
#ifndef IDKLTSamplingINCLUDE
#define IDKLTSamplingINCLUDE

#include "core/vector/VectorT.h"
#include "core/vector/MatrixT.h"
#include "core/image/ImageT.h"

#include "core/basics/Config.h"
#include "InterestDetector.h"

namespace OBJREC
{

/** random interest point sampling */
class IDKLTSampling: public InterestDetector
{

protected:
	int numSamples;
	double minScale;

	bool fixedOrientation;

public:

	IDKLTSampling(const NICE::Config *conf, int numSamples);

	virtual ~IDKLTSampling();
	int getInterests(const NICE::Image & img,
			std::vector<NICE::Vector> & positions) const;
	int getInterests(const ImagePyramid & imp,
			std::vector<NICE::Vector> & positions) const;

};

} // namespace

#endif
