/** 
* @file LocalFeatureRepresentation.cpp
* @brief absract class for the representation of an image with local feature descriptors
* @author Erik Rodner
* @date 11/19/2007

*/
#include <iostream>

#include "vislearning/features/localfeatures/LocalFeatureRepresentation.h"

using namespace OBJREC;

using namespace std;
using namespace NICE;



LocalFeatureRepresentation::LocalFeatureRepresentation()
{
}

LocalFeatureRepresentation::~LocalFeatureRepresentation()
{
}

int LocalFeatureRepresentation::extractFeatures ( const NICE::ColorImage & img, 
		      VVector & features, 
		      VVector & positions) const
{
    fthrow( Exception, "LocalFeatureRepresentation::extractFeatures local feature extraction from color images not supported\n");
}

void LocalFeatureRepresentation::visualize ( NICE::Image & img, 
				 const NICE::Vector & feature ) const
{
    fthrow( Exception, "LocalFeatureRepresentation::visualize visualization not yet implemented\n");
}

void LocalFeatureRepresentation::visualizeFeatures ( NICE::Image & mark,
				 const VVector & positions,
				 size_t color ) const
{
	fthrow( Exception, "LocalFeatureRepresentation::visualize visualization not yet implemented\n");
}
