/** 
* @file FCGetFeature.h
* @brief interface to GetFeature
* @author Erik Rodner
* @date 10.09.2007

*/

#ifdef NICE_USELIB_ICE

#ifndef FCGetFEATUREINCLUDE
#define FCGetFEATUREINCLUDE

#include <ocr/GetFeature.h>

#include "vislearning/features/fbase/FeatureFactory.h"


namespace OBJREC {

/** interface to GetFeature */
class FCGetFeature : public FeatureFactory
{

    protected:
	ice::GetFeature *gf;

    public:
  
	/** simple constructor */
	FCGetFeature( const NICE::Config *conf, 
		      ice::GetFeature *gf );
      
	/** simple destructor */
	virtual ~FCGetFeature();
     
	/** return feature vector for this image */
	virtual int convert ( const NICE::Image & img, NICE::Vector & vec );
};

} // namespace

#endif

#endif