/** 
* @file FCWriteCache.h
* @author Erik Rodner
* @date 11/15/2007

*/
#ifndef FCWriteCacheINCLUDE
#define FCWriteCacheINCLUDE

#include "core/vector/VectorT.h"
#include "core/vector/MatrixT.h"

 
#include "vislearning/features/fbase/FeatureFactory.h"


namespace OBJREC {

class FCWriteCache : public FeatureFactory
{
    protected:

	std::string cachedir;
	int cachemode;

	FeatureFactory *ff;

    public:
  
	/** simple constructor */
	FCWriteCache ( const NICE::Config *conf, FeatureFactory *ff );
      
	/** simple destructor */
	virtual ~FCWriteCache();
     
	int convert ( const NICE::Image & img, NICE::Vector & vec );
};


} // namespace

#endif
