/** 
* @file GenerateSignature.h
* @brief Abstract Interface for generation of signatures form local features
* @author Erik Rodner
* @date 10/30/2007

*/
#ifndef GENERATESIGNATUREINCLUDE
#define GENERATESIGNATUREINCLUDE

#include "core/vector/VectorT.h"
#include "core/vector/MatrixT.h"

#include "core/basics/Config.h"
#include "core/vector/VVector.h"


namespace OBJREC {

/** Abstract Interface for generation of signatures form local features */
class GenerateSignature
{

    protected:

    public:
  
	/** simple constructor */
	GenerateSignature ( const NICE::Config *conf );
      
	/** simple destructor */
	virtual ~GenerateSignature();


	virtual void signature ( const NICE::VVector & features,
			 NICE::Vector & signature ) = 0;
     
};


} // namespace

#endif
