/** 
* @file EMDDistanceSingle.h
* @brief Earth Movers Distance
* @author Erik Rodner
* @date 10/24/2007

*/
#ifndef EMDDistanceSingleINCLUDE
#define EMDDistanceSingleINCLUDE

#include "core/vector/VectorT.h"
#include "core/vector/MatrixT.h"
  
#include <core/vector/Distance.h>


namespace OBJREC {

/** Earth Movers Distance */
class EMDDistanceSingle : public NICE::VectorDistance<double>
{

    protected:
	double doCalculate (const NICE::Vector & x, const NICE::Vector & y) const;

    public:
  
	/** simple constructor */
	EMDDistanceSingle();
      
	/** simple destructor */
	virtual ~EMDDistanceSingle();
	
     
};


} // namespace

#endif
