/** 
* @file HistIntersectDistance.h
* @brief $\chi^2$ distance measure
* @author Erik Rodner
* @date 02/19/2008

*/
#ifndef HistIntersectDistanceINCLUDE
#define HistIntersectDistanceINCLUDE

#include "core/vector/VectorT.h"
#include "core/vector/MatrixT.h"
  
#include <core/vector/Distance.h>


namespace OBJREC {

/** \chi^2 distance measure */
class HistIntersectDistance : public NICE::VectorDistance<double>
{

    protected:
	double doCalculate (const NICE::Vector & x, const NICE::Vector & y) const;

    public:
  
	/** simple constructor */
	HistIntersectDistance();
      
	/** simple destructor */
	virtual ~HistIntersectDistance();
     
};


} // namespace

#endif
