/** 
* @file MaxDistance.h
* @brief maximum distance measure
* @author Erik Rodner
* @date 02/19/2008

*/
#ifndef MaxDistanceINCLUDE
#define MaxDistanceINCLUDE

#include "core/vector/VectorT.h"
#include "core/vector/MatrixT.h"

#include <core/vector/Distance.h>
  

namespace OBJREC {

/** maximum distance measure */
class MaxDistance : public NICE::VectorDistance<double>
{

    protected:
	double doCalculate (const NICE::Vector & x, const NICE::Vector & y) const;

    public:
  
	/** simple constructor */
	MaxDistance();
      
	/** simple destructor */
	virtual ~MaxDistance();
     
};


} // namespace

#endif
