/** 
* @file KernelFixed.cpp
* @brief Standard kernel
* @author Erik Rodner
* @date 10/24/2007

*/

#include <iostream>

#include "KernelFixed.h"

using namespace OBJREC;

using namespace std;
using namespace NICE;



KernelFixed::KernelFixed( ParameterizedKernel *_mykernel ) : Kernel(true), mykernel(_mykernel)
{
}

KernelFixed::~KernelFixed()
{
}

double KernelFixed::K (const NICE::Vector & x, const NICE::Vector & y) const
{
	return mykernel->K(x,y);
}
	
void KernelFixed::calcKernelData ( const VVector & vecSet, KernelData *kernelData ) const
{
	mykernel->calcKernelData ( vecSet, kernelData );
}
