/** 
* @file KernelFixed.h
* @brief Standard kernel
* @author Erik Rodner
* @date 10/24/2007

*/
#ifndef KERNELSTDINCLUDE
#define KERNELSTDINCLUDE

#include "Kernel.h"
#include "ParameterizedKernel.h"


namespace OBJREC {

/** Standard kernel */
class KernelFixed : public Kernel
{

    protected:
		ParameterizedKernel *mykernel;

    public:
  
	/** simple constructor */
	KernelFixed( ParameterizedKernel *mykernel );
      
	/** simple destructor */
	virtual ~KernelFixed();
	
	double K (const NICE::Vector & x, const NICE::Vector & y) const;
     
	void calcKernelData ( const NICE::VVector & vecSet, KernelData *kernelData ) const;
};


} // namespace

#endif
