/** 
* @file MAPMultinomialDirichlet.h
* @brief MAP estimation of a multinomial using a dirichlet prior
* @author Erik Rodner
* @date 10/30/2008

*/
#ifndef MAPMultinomialDirichletINCLUDE
#define MAPMultinomialDirichletINCLUDE

#include "core/image/ImageT.h"
#include "core/vector/VectorT.h"
#include "core/vector/MatrixT.h"
 
#include "MAPEstimation.h"


namespace OBJREC {

/** map estimation of a multinomial using a dirichlet prior */
class MAPMultinomialDirichlet : public MAPEstimation
{
    public:
  
	virtual void estimate (	NICE::Vector & mapEstimate,
			 const NICE::VVector & likelihoodDistributionSamples,
			 const NICE::VVector & priorDistributionSamples,
			 double priorInfluence );
};


} // namespace

#endif
