/** 
* @file GPModelSelectionCriterion.h
* @author Erik Rodner
* @date 03/07/2010

*/
#ifndef _NICE_OBJREC_GPMODELSELECTIONCRITERIONINCLUDE
#define _NICE_OBJREC_GPMODELSELECTIONCRITERIONINCLUDE

#include "core/vector/VectorT.h"
#include "vislearning/math/kernels/KernelData.h"


namespace OBJREC {
  
/** @class GPModelSelectionCriterion
 * Model selection criterions for Gaussian Processes 
 *
 * @author Erik Rodner
 */
class GPModelSelectionCriterion
{
    public:
  
		/** simple destructor */
		virtual ~GPModelSelectionCriterion();
    
		virtual double computeObjective ( KernelData *kernelData, const NICE::Vector & labels ) const = 0;
};

}

#endif
